C ASCII "0"
      PROGRAM PLAYER
C
C     MAY 1980	BILL CAEL AND BILL WOOD	RECODED IN RATFOR
C     MAY 1980	BILL CAEL AND BILL WOOD	ADDED DEFAULT SHIP AND DIRECTION
C     MAY 1980		BILL WOOD	ADDED ENERGY NETS
C     MAY 1980	BILL CAEL AND BILL WOOD	RECODED OUTPUT
C     MAY 1980  BILL CAEL, BILL WOOD, AND BOB STODOLA
C					RECODED COMMAND ARG PROMPTING
C     NOV 1980	BILL WOOD		CONVERTED TO RUN ON VAX
C
C	July/August 1981	Stuart Renes, Western Electric Co.
C	Mixed Case messages, added sound effects
C	Improved Driver controls
C	^C Intercept AST, Exit handler
C	Play periods (including weekend control)
C	VT100 advanced video features - renamed GALAXY V1.0
C	Lowered Refresh rates in half
C
C	Version 1.1	September 8th, 1981
C	Added purge of type-ahead when destroyed or at games end.
C
C	Version 1.2	September 10th, 1981
C	Added silent play option.
C
C	Version 1.3	September 17th, 1981
C	Added Shared Command Display and control.
C	More code cleanup.
C
C	Version 1.4	September 23rd, 1981
C	Tighten window in which users can beat the "SHARED" feature.
C
C	Version 1.5	September 27th, 1981
C	Fix bugs that creeped in from V1.4.
C
C	Version 1.6	October 2nd, 1981
C	Changed Initialization to force active players off.
C	Slight esthetic change at close of game period.
C	Describe previously un-documented features in HELP file.
C
     TEXT COMMON
      COMMON/TORPE/TLOCS(8, 10, 2), TDIR(8, 10), IT(8)
      COMMON/LEDFOR/ENERGY(8), SHIELD(8), XCORD(8), YCORD(8), TORPS(8), 
     *HX, HY, HW, CDRAIN, NDRAIN, TDRAIN, SCAN(8), PHA(8), I1, I2, HYPER
     *(8), ISENT(8, 10), XPOD(8), YPOD(8), DPOD(8), IPOD(8), WPOD(8), XH
     *OM(8, 4), YHOM(8, 4), WHOM(8, 4), NHOM(8), TRBEAM(8), SCORE(8), CR
     *EW(8), DIR(8), WARP(8), LAUNCH(8), UNIV(100, 100), MESSAG(480), TH
     *RU, XSHIP(8), CLOAK(8), NET(8), BHOLE, EMPTY
      REAL LAUNCH, NDRAIN
      INTEGER SCAN, WHOM, CREW, HYPER, TORPS, TRBEAM
      LOGICAL*1THRU, XSHIP, CLOAK, NET
C NOTE: BHOLE AND EMPTY ARE THE CHARACTERS FOR THE BLACK HOLE
C       AND EMPTY SPACE AND ARE SET IN MTREKINI.
      BYTE UNIV, MESSAG, BHOLE, EMPTY
C     END COMMON
	common/local/shrflg(8)
	common/double/share(8),busy(8)
	logical*1 busy
	integer share,shrflg,day
	character*9 today
	character*80 header
	character*4 V
	data V /'V1.6'/
	common/signal/playtm
	integer timcnt
	data timcnt/4/
	logical*1 playtm,wizard,myplay,shpflg,yesshr
      LOGICAL*1OK, DONE, YES, WARN, REFRES, REFTOG
      LOGICAL QUIKUP,supflg
	common done
	common/silent/belflg
	logical*1 belflg
	character*19 paswrd,answer
	character*8 timbf
	byte pasbuf(19)
	data paswrd/'starship enterprise'/
      REAL SC(9), R(9)
      INTEGER DEFSHP, OLDSHP
      REAL DEFDIR, OLDDIR
      COMMON/DEFLTS/DEFSHP, DEFDIR, OLDDIR, OLDSHP, DEFSHD
      LOGICAL CLEARF, VERBOS
      COMMON/MESS/CLEARF, VERBOS
      BYTE BLANK(80), ALPHA, MESBUF(60)
      REAL D1(4)
      BYTE BLUNK(2)
      BYTE BLUNK2(2)
      BYTE OBUFF( - 9: + 9,  - 9: + 9)
      BYTE JUNK, NBUFF
      COMMON/BNDRY/IXX, IYY, ID, MINID8, JUNK, NBUFF( - 9: + 9,  - 9: + 
     *9)
      INTEGER COMMND
	common/me/who
      INTEGER WHO
      EQUIVALENCE(BLUNK(2), NBUFF( - 9,  - 9))
      EQUIVALENCE(BLUNK2(2), OBUFF( - 9,  - 9))
      DATA BLANK/80*' '/
      DATA BLUNK, BLUNK2/4*' '/
      DATA SC/9* - 9999./
      DATA R/9* - 9999./
      DATA DONE/.FALSE./
      DATA OK/.FALSE./
	wizard=.false.
      DATA DEFDIR/0.0/, DEFSHD/0.0/
C
C  QUIKUP IS SET TRUE IF TERMINAL SPEED EXCEEDS A THRESHOLD
C  DETERMINED IN GTCHAR.
C  IF QUIKUP IS TRUE, A FULL SCREEN UPDATE OCCURS EVERY 1/2 SECOND;
C  AT SLOWER SPEEDS, 1/2 THE SCREEN IS UPDATED EVERY SECOND ON THE
C  HALF SECOND, THE OTHER 1/2 IS UPDATED EVERY SECOND ON THE SECOND.
C  THIS ALLOWS ENJOYABLE GAMES ON TERMINALS AS SLOW AS 1200 BAUD.
C
C GET QUIKUP, INITIALIZE TERMINAL IO
C
C If supflg is .FALSE. then terminal type is NOT supported and we will
C exit and give him an explaination.
C If MYPLAY is .FALSE. then it must be OFFHOURS and we won't let him in!
C
      CALL GTCHAR(QUIKUP,supflg)
	If (supflg) goto 1000
	write(5,1999)
1999	format(' You obviously didn''t read the instructions
	1 about terminal setup.')
	call exit
1000	call daytim(myplay)
	call video('<')
	If (myplay) goto 1998
	call clear
	call outch(0,0)
	write(5,1995)
1995	format(' I''m sorry but the Galaxy is CLOSED now.',//,
	1' Entrance is allowed only to those who can',/,
	1'$demonstrate their worthiness. ')
	call inchar(pasbuf,19,.false.,3,nc,ierr)
	call clear
	call outch(0,0)
	if (ierr .ge. 0) goto 1993
	If (ierr .eq. -2) then
	call video('5')
	write(5,1992)
1992	format(' I''m sorry but you are clearly unworthy!',/
	1,' Come back during regular hours of play.')
	call video('0')
	call exit
	endif
1993	encode(19,9934,answer)pasbuf
9934	format(19a1)
	If (answer .ne. paswrd) goto 1996
	wizard=.true.
	goto 1998
1996	call video('5')
	write(5,1992)
	call video('0')
	call exit
1998	call clear
	call outch(0,0)
	call weekday(day)
	call date(today)
	If (day .eq. 0)header='Welcome to GALAXY '//V//' on Wednesday, '//today
	If (day .eq. 1) header='Welcome to GALAXY '//V//' on Thursday, '//today
	If (day .eq. 2) header='Welcome to GALAXY '//V//' on Friday, '//today
	If (day .eq. 3) header='Welcome to GALAXY '//V//' on Saturday, '//today
	If (day .eq. 4) header='Welcome to GALAXY '//V//' on Sunday, '//today
	If (day .eq. 5) header='Welcome to GALAXY '//V//' on Monday, '//today
	If (day .eq. 6) header='Welcome to GALAXY '//V//' on Tuesday, '//today
	If (day .gt. 6) header='Welcome to GALAXY '//V//', '//today
	ih=index(header,'-')
      WRITE(5, 1001)header(1:ih+6) 
1001	format(' ',a)
2000  CONTINUE
        WRITE(5, 1011) 
1011    FORMAT('0The following Vessels are available:'/)
	shpflg=.false.
        DO 2030 I = 1, 8
          IF (.NOT.(.NOT.XSHIP(I))) GOTO 2050
	If (busy(i)) goto 2050
            WRITE(5, 1021) I
1021        FORMAT(' Ship ', I1)
	shpflg=.true.
2050      CONTINUE
2030    CONTINUE
2040    CONTINUE
	if (shpflg) goto 1030
	write(5,1032)
1032	format(' I''m sorry but all Ships have launched...',/,
	1' It may be possible to share a Command...')
1030        WRITE(5, 1031) 
1031    FORMAT(/'$Pick a Ship from our starfleet: ')
        CALL GETINT(0, IW, OK, 1, 8, 0)
        IF (.NOT.(OK)) GOTO 2070
          IF (.NOT.(IW .EQ. 0)) GOTO 2090
            OK = .FALSE.
            GOTO 2010
2090      CONTINUE
          WHO = IW
	If (.not.(busy(who))) goto 1039
	Write(5,9699)who
9699	format('0Sorry, ship ',i1,' is temporarily disabled!')
	goto 1042
1039          IF (.NOT.(XSHIP(WHO))) GOTO 2110
	If (share(who).eq.-1.or.share(who).eq.1) then
9918            WRITE(5, 1041)who 
1041        FORMAT('0Ship ',i1' already has a full crew. Sorry!')
1042	call wait(60,1,m)
	goto 1998
	endif
            WRITE(5, 1051)who 
1051        FORMAT('$Ship ',i1,' already has a Commander.',
	1' Do you wish to share this Command? ')
            CALL YESNO(0, OK)
	If ((ok) .and. (share(who) .eq. 1 .or. share(who) .eq. -1)) goto 9918
	If (ok) share(who)=1
2110      CONTINUE
          GOTO 2080
2070     CONTINUE
	call clear
	call outch(0,0)
	write(5,4554)
4554	format(' Those who cannot follow instructions
	1 cannot become Starfleet Commanders!')
          CALL EXIT
2080    CONTINUE
2010    IF (.NOT.(OK)) GOTO 1998
2020  CONTINUE
	If (.not.(xship(who))) then
	xship(who)=.true.
		If (share(who) .eq. 0) then
		header='Allow Sharing? '
		call respnd(header,yesshr)
		If (share(who) .eq. 0 .and. (.not.(yesshr))) share(who)=-1
		If (share(who) .eq. 1 .and. (.not.(yesshr))) then
		write(5,901)
901	format(' Oops, someone else has slipped into the cockpit!')
		endif
		else
		yesshr=.true.
		endif
	endif
	header='Silent Game? '
	call respnd(header,belflg)
	call video('h')
      REFRES = .TRUE.
      REFTOG = .FALSE.
      CREW(WHO) = CREW(WHO) + 1
      DEFSHP = WHO
      CALL STRMOV(BLUNK2, 1, 361, OBUFF, 1)
      CALL RBUFF
      IF (.NOT.(.NOT.QUIKUP)) GOTO 2130
C START 1 SECOND TIMER IF SLOW UPDATE
        CALL MARK(3, 30, 1, IDS)
2130  CONTINUE
C START 1/2 SECOND TIMER
      CALL MARK(2, 15, 1, IDS)
2150  CONTINUE
C
C       THE FOLLOWING CALL SPAWNS THE MTREKD UNIVERSE MANAGER TASK ON TT0:.
C       IF YOU CANNOT DO SOMETHING SIMILAR, YOU MUST START MTREKD YOURSELF
C       BEFORE PLAYING EACH GAME.
C
        IF (.NOT.(THRU)) GOTO 2180
C THEN MTREKD ISN'T RUNNING
c          CALL RUNMTR
C
C     PLACE LOCAL SCAN ON TERMINAL
C
2180    CONTINUE
	timcnt=timcnt+1
	if (timcnt .lt. 4) goto 9078
	timcnt=0
	call time(timbf)
	call tpos(12,70)
	encode(8,9009,mesbuf)timbf
9009	format (a8)
	call outch(mesbuf,8)
9078	call video('7')
        REFTOG = (.NOT.REFTOG) .OR. QUIKUP
        IF (.NOT.((XSHIP(WHO) .AND. REFTOG) .OR. REFRES)) GOTO 5555
C DON'T REFRESH IF BLOWN UP!
          CALL STRMOV(BLUNK, 1, 361, NBUFF, 1)
          ID = SCAN(WHO)
          MINID8 = MIN(ID, 8)
          IXX = XCORD(WHO)
          IYY = YCORD(WHO)
          IXLOW = MAX(2, IXX - ID)
          IXHI = MIN(99, IXX + ID)
          IYLOW = MAX(2, IYY - ID)
          IYHI = MIN(99, IYY + MINID8)
          DO 2220 IX1 = IXLOW, IXHI
            IX = IX1 - IXX
            DO 2240 IY1 = IYLOW, IYHI
              IY = IY1 - IYY
              ALPHA = UNIV(IX1, IY1)
              IF (.NOT.((ALPHA .GE. 48+1) .AND. (ALPHA .LE. 48+8) .AND. 
     *(CLOAK(ALPHA-48)))) GOTO 2260
                NBUFF(IX, IY) = EMPTY
                GOTO 2270
2260           CONTINUE
                IF (.NOT.(ALPHA .LT. 0)) GOTO 2280
                  NBUFF(IX, IY) = '%'
                  GOTO 2290
2280             CONTINUE
                  NBUFF(IX, IY) = ALPHA
2290            CONTINUE
2270          CONTINUE
2240        CONTINUE
2250        CONTINUE
2220      CONTINUE
2230      CONTINUE
          IF (.NOT.(IXX-ID .LE. 1)) GOTO 2300
            CALL BNDRY(1, 1, MAX(1, IYY - ID), MIN(100, IYY + MINID8))
            GOTO 2310
2300       CONTINUE
            IF (.NOT.(IXX+ID .GE. 100)) GOTO 2320
              CALL BNDRY(100, 100, MAX(1, IYY - ID), MIN(100, IYY + MINI
     *D8))
2320        CONTINUE
2310      CONTINUE
          IF (.NOT.(IYY-ID .LE. 1)) GOTO 2340
            CALL BNDRY(MAX(1, IXX - ID), MIN(99, IXX + ID), 1, 1)
            GOTO 2350
2340       CONTINUE
            IF (.NOT.(IYY+ID .GE. 100)) GOTO 2360
              CALL BNDRY(MAX(1, IXX - ID), MIN(99, IXX + ID), 100, 100)
2360        CONTINUE
2350      CONTINUE
          IF (.NOT.(NBUFF(-ID, -ID) .EQ. EMPTY)) GOTO 2380
            NBUFF( - ID,  - ID) = '.'
2380      CONTINUE
          IF (.NOT.(NBUFF(-ID, MINID8) .EQ. EMPTY)) GOTO 2400
            NBUFF( - ID, MINID8) = '.'
2400      CONTINUE
          IF (.NOT.(NBUFF(ID, MINID8) .EQ. EMPTY)) GOTO 2420
            NBUFF(ID, MINID8) = '.'
2420      CONTINUE
          IF (.NOT.(NBUFF(ID, -ID) .EQ. EMPTY)) GOTO 2440
            NBUFF(ID,  - ID) = '.'
2440      CONTINUE
          DO 2460 IY =  - 9,  + 8
            ICURSX =  - 999
            DO 2480 IX =  - 9,  + 9
              IF (.NOT.(NBUFF(IX, IY) .NE. OBUFF(IX, IY))) GOTO 2500
                IF (.NOT.(ICURSX .GE. IX-2)) GOTO 2520
                  DO 2540 III = ICURSX + 1, IX
                    CALL OUTCH(' ', 1)
                    CALL OUTCH(NBUFF(III, IY), 1)
2540              CONTINUE
2550              CONTINUE
                  GOTO 2530
2520             CONTINUE
                  CALL TPOS(9 - IY, 2*IX + 43)
                  CALL OUTCH(NBUFF(IX, IY), 1)
2530            CONTINUE
                ICURSX = IX
                OBUFF(IX, IY) = NBUFF(IX, IY)
2500          CONTINUE
2480        CONTINUE
2490        CONTINUE
2460      CONTINUE
2470      CONTINUE
          CALL OUTCH(0,  - 1)
5555	call video('0')
C
C     THE FOLLOWING WAIT CONTROLS THE UPDATE RATE, WHICH IS NORMALLY
C     SET TO A HALF SECOND (30 CLOCK TICKS).
C
2200    CONTINUE
        IF (.NOT.(COMMND .NE. '  ' .AND. XSHIP(WHO))) GOTO 2560
          IF (.NOT.(REFTOG)) GOTO 2580
            CALL WAITFR(2, IDS)
            IF (.NOT.(QUIKUP)) GOTO 2600
C RESTART 1/2 SECOND TIMER
              CALL MARK(2, 15, 1, IDS)
2600        CONTINUE
            GOTO 2590
2580       CONTINUE
            CALL WAITFR(3, IDS)
C RESTART 1 SECOND TIMER
            CALL MARK(3, 30, 1, IDS)
C RESTART 1/2 SECOND TIMER
            CALL MARK(2, 15, 1, IDS)
2590      CONTINUE
2560    CONTINUE
	Do 7666 ibb=1,8
	If (share(ibb) .ne. -1) then
		If (shrflg(ibb) .ne. share(ibb)) then
	if (share(ibb) .eq. 1) then
	if (ibb .eq. who) then
	call video('1')
	else
	call video('7')
	endif
		call buffil((ibb+1),63,'Shr''d',5)
	If (ibb .eq. who) then
	call video('0')
	endif
	endif
	if (share(ibb) .eq. 0) then
		call buffil((ibb+1),63,'     ',5)
	endif
	shrflg(ibb)=share(ibb)
	endif
	endif
7666	continue
	If (playtm) goto 2998
	If (wizard) goto 2998
	crew(who)=crew(who)-1
	if (.not.(crew(who) .le. 400)) goto 9979
	xship(who)=.false.
	goto 9969
9979	xship(who)=.true.
9969	call outch(0,0)
	call purge
	call beeper(7)
	call tpos(23,20)
	call video('1')
	call outstr(.false.,'The GALAXY is now closed.  Thanks for playing
	1!',.false.)
	call video('0')
	call outch(0,0)
	If (share(who) .eq. 1) share(who)=0
	If (.not.(yesshr)) share(who)=0
	call exit
2998        NC = 1
        COMMND = '0 '
        IF (.NOT.(XSHIP(WHO))) GOTO 2620
          CALL TREAD(COMMND, NC)
C
C     CHECK FOR NO INPUT
C
2620    CONTINUE
        IF (.NOT.(COMMND .EQ. '0 ')) GOTO 2640
C
C     LONG RANGE SCAN COMMAND
C
          GOTO 2650
2640     CONTINUE
          IF (.NOT.(COMMND .EQ. 'L ')) GOTO 2660
            CALL GETINT('Target Ship? ', II, OK, 1, 8, DEFSHP)
            IF (.NOT.(OK)) GOTO 2680
              DEFSHP = II
              IX = XCORD(II)/10.
              IY = YCORD(II)/10.
              CALL TPOS(18, 75)
              ENCODE(5, 1071, MESBUF) IX, IY
1071          FORMAT(I2, ',', I2)
              CALL OUTCH(MESBUF, 5)
              XX = XCORD(WHO)
              YY = YCORD(WHO)
              X1 = XCORD(II)
              IF (.NOT.(X1 .LT. 51.)) GOTO 2700
                X2 = X1 + 100.
                GOTO 2710
2700           CONTINUE
                X2 = X1 - 100.
2710          CONTINUE
              Y1 = YCORD(II)
              IF (.NOT.(Y1 .LT. 51.)) GOTO 2720
                Y2 = Y1 + 100.
                GOTO 2730
2720           CONTINUE
                Y2 = Y1 - 100.
2730          CONTINUE
              D1(1) = ((XX - X1)**2 + (YY - Y1)**2)**.5
              D1(2) = ((XX - X1)**2 + (YY - Y2)**2)**.5
              D1(3) = ((XX - X2)**2 + (YY - Y1)**2)**.5
              D1(4) = ((XX - X2)**2 + (YY - Y2)**2)**.5
              IIT = 1
              DO 2740 J = 2, 4
                IF (.NOT.(D1(J) .LT. D1(IIT))) GOTO 2760
                  IIT = J
2760            CONTINUE
2740          CONTINUE
2750          CONTINUE
              D = D1(IIT)
              IF (.NOT.(IIT .EQ. 1)) GOTO 2780
                YD = Y1
                XD = X1
                GOTO 2790
2780           CONTINUE
                IF (.NOT.(IIT .EQ. 2)) GOTO 2800
                  YD = Y2
                  XD = X1
                  GOTO 2810
2800             CONTINUE
                  IF (.NOT.(IIT .EQ. 3)) GOTO 2820
                    YD = Y1
                    XD = X2
                    GOTO 2830
2820               CONTINUE
                    YD = Y2
                    XD = X2
2830              CONTINUE
2810            CONTINUE
2790          CONTINUE
              EDIS = D
              EDIR = ATAN3((YD - YY), (XD - XX))*57.29577951
              IF (.NOT.(EDIR .LT. 0.)) GOTO 2840
                EDIR = EDIR + 360.
2840          CONTINUE
              IF (.NOT.(EDIR .GT. 90.)) GOTO 2860
                EDIR = (450. - EDIR)/30.
                GOTO 2870
2860           CONTINUE
                EDIR = (90. - EDIR)/30.
2870          CONTINUE
              DEFDIR = EDIR
              CALL TPOS(17, 75)
              ENCODE(5, 1081, MESBUF) EDIS
1081          FORMAT(F5.2)
              CALL OUTCH(MESBUF, 5)
              CALL TPOS(16, 75)
              ENCODE(5, 1091, MESBUF) EDIR
1091          FORMAT(F5.2)
              CALL OUTCH(MESBUF, 5)
              CALL TPOS(15, 79)
              ENCODE(1, 1101, MESBUF) DEFSHP
1101          FORMAT(I1)
              CALL OUTCH(MESBUF, 1)
              CALL OUTCH(0,  - 1)
2680        CONTINUE
C
C     TORPEDO COMMAND
C
            GOTO 2670
2660       CONTINUE
            IF (.NOT.(COMMND .EQ. 'T ')) GOTO 2880
              IF (.NOT.(LAUNCH(WHO) .LT. 0.)) GOTO 2900
                IF (.NOT.(TORPS(WHO) .GT. 0)) GOTO 2920
             CALL GETREL('Torpedo Course? ', VALUE, OK, 0., 12., DE
     *FDIR)
                  IF (.NOT.(OK)) GOTO 2940
                    DEFDIR = VALUE
                    IF (.NOT.(VALUE .GE. 3.)) GOTO 2960
                      VALUE = (15. - VALUE)*30.
                      GOTO 2970
2960                 CONTINUE
                      VALUE = (3. - VALUE)*30.
2970                CONTINUE
                    LAUNCH(WHO) = VALUE
                    TORPS(WHO) = TORPS(WHO) - 1
                    IF (.NOT.(TORPS(WHO) .EQ. 0)) GOTO 2980
			call beeper(1)
                      CALL MESSGE('Last Torpedo!')
2980                CONTINUE
2940              CONTINUE
                  GOTO 2930
2920             CONTINUE
			call beeper(1)
                  CALL MESSGE('No Torpedoes!')
2930            CONTINUE
                GOTO 2910
2900           CONTINUE
			call beeper(1)
                CALL MESSGE('Torpedoes not ready.')
2910          CONTINUE
C
C     PHASER COMMAND
C
              GOTO 2890
2880         CONTINUE
              IF (.NOT.(COMMND .EQ. 'P ')) GOTO 3000
                IF (.NOT.(PHA(WHO) .LT. 0.)) GOTO 3020
             CALL GETREL('Phaser Course? ', VALUE, OK, 0., 12., DEF
     *DIR)
                  IF (.NOT.(OK)) GOTO 3040
                    DEFDIR = VALUE
                    IF (.NOT.(VALUE .GE. 3.)) GOTO 3060
                      VALUE = (15. - VALUE)*30.
                      GOTO 3070
3060                 CONTINUE
                      VALUE = (3. - VALUE)*30.
3070                CONTINUE
                    PHA(WHO) = VALUE
                    ENERGY(WHO) = ENERGY(WHO) - 50.
3040              CONTINUE
                  GOTO 3030
3020             CONTINUE
			call beeper(1)
                  CALL MESSGE('Phasers not ready.')
3030            CONTINUE
C
C      HOMING TORPEDO LAUNCH
C
                GOTO 3010
3000           CONTINUE
                IF (.NOT.(COMMND .EQ. 'K ')) GOTO 3080
                  IF (.NOT.(NHOM(WHO) .EQ. 4)) GOTO 3100
                    TWHOM = 0.
                    GOTO 3110
3100               CONTINUE
                    TWHOM = WHOM(WHO, NHOM(WHO) + 1)
3110              CONTINUE
                  IF (.NOT.(TWHOM .GE. 0.)) GOTO 3120
                    IF (.NOT.(NHOM(WHO) .GT. 0)) GOTO 3140
                 CALL GETINT('Target Ship? ', II, OK, 1, 8, DE
     *FSHP)
                      IF (.NOT.(OK)) GOTO 3160
                        DEFSHP = II
                        IF (.NOT.(II .EQ. WHO)) GOTO 3180
				call beeper(1)
                          CALL MESSGE('Torpedoes jammed!')
                          NHOM(WHO) = 0
                          TORPS(WHO) = 0
                          GOTO 3190
3180                     CONTINUE
                          WHOM(WHO, NHOM(WHO)) =  - II
                          NHOM(WHO) = NHOM(WHO) - 1
3190                    CONTINUE
3160                  CONTINUE
                      GOTO 3150
3140                 CONTINUE
				call beeper(1)
                      CALL MESSGE('No Seekers!')
3150                CONTINUE
                    GOTO 3130
3120               CONTINUE
				call beeper(1)
                    CALL MESSGE('Seekers not ready.')
3130              CONTINUE
C
C     WARP FACTOR COMMAND
C
                  GOTO 3090
3080             CONTINUE
                  IF (.NOT.(COMMND .EQ. 'W ')) GOTO 3200
                CALL GETREL('Warp Sir? ', VALUE, OK, 0., 8., WARP(WH
     *O))
                    IF (.NOT.(OK)) GOTO 3220
                      WARP(WHO) = VALUE
3220                CONTINUE
C
C     COURSE COMMAND
C
                    GOTO 3210
3200               CONTINUE
                    IF (.NOT.(COMMND .EQ. 'C ')) GOTO 3240
                  CALL GETREL('Course Sir? ', VALUE, OK, 0., 12., DE
     *FDIR)
                      IF (.NOT.(OK)) GOTO 3260
                        IF (.NOT.(VALUE .GE. 3.)) GOTO 3280
                          DIR(WHO) = (15. - VALUE)*30.
                          GOTO 3290
3280                     CONTINUE
                          DIR(WHO) = (3. - VALUE)*30.
3290                    CONTINUE
3260                  CONTINUE
C
C     EXPLODE ANTI-MATTER DEVICE
C
                      GOTO 3250
3240                 CONTINUE
                      IF (.NOT.(COMMND .EQ. 'X ')) GOTO 3300
                        IF (.NOT.(IPOD(WHO) .EQ. 2)) GOTO 3320
                          IPOD(WHO) = 3
                          CALL MESSGE('Detonation signaled.')
                          GOTO 3330
3320                     CONTINUE
				call beeper(1)
                          CALL MESSGE('No Pod!')
3330                    CONTINUE
C
C     CONVERT MOVING ANTI-MATTER POD TO A STATIC MINE
C
                        GOTO 3310
3300                   CONTINUE
                        IF (.NOT.(COMMND .EQ. 'N ')) GOTO 3340
                          IF (.NOT.(IPOD(WHO) .EQ. 2)) GOTO 3360
                            WPOD(WHO) = 0.
                            CALL MESSGE('Pod positioned.')
                            GOTO 3370
3360                       CONTINUE
				call beeper(1)
                            CALL MESSGE('No Pod!')
3370                      CONTINUE
C
C     LAUNCH ANTI-MATTER DEVICE
C
                          GOTO 3350
3340                     CONTINUE
                          IF (.NOT.(COMMND .EQ. 'Z ')) GOTO 3380
                            IF (.NOT.(IPOD(WHO) .EQ. 0)) GOTO 3400
                         CALL GETREL('Pod Course? ', VALUE, OK, 0.,
     * 12., DEFDIR)
                              IF (.NOT.(OK)) GOTO 3420
                                DEFDIR = VALUE
                                IF (.NOT.(VALUE .GE. 3.)) GOTO 3440
                                  DPOD(WHO) = (15. - VALUE)*30.
                                  GOTO 3450
3440                             CONTINUE
                                  DPOD(WHO) = (3. - VALUE)*30.
3450                            CONTINUE
                                IPOD(WHO) = 1
3420                          CONTINUE
                              GOTO 3410
3400                         CONTINUE
				call beeper(1)
                              CALL MESSGE('No Pod!')
3410                        CONTINUE
C
C     HYPERSPACE COMMAND
C
                            GOTO 3390
3380                       CONTINUE
                            IF (.NOT.(COMMND .EQ. 'H ')) GOTO 3460
                              IUNIQ = HYPER(WHO)
                         CALL GETINT('Hyper Port? ', II, OK, 1, 6, 
     *IUNIQ)
                              IF (.NOT.(OK)) GOTO 3480
                                HYPER(WHO) = II
3480                          CONTINUE
C
C     SHIELD COMMAND
C
                              GOTO 3470
3460                         CONTINUE
                              IF (.NOT.(COMMND .EQ. 'S ')) GOTO 3500
                            CALL GETREL('Energy Change? ', VALUE, OK
     *,  - 1.E36, 1.E36, DEFSHD)
                                IF (.NOT.(OK)) GOTO 3520
                                  IF (.NOT.(ENERGY(WHO)-VALUE .GE. 0. .A
     *ND. SHIELD(WHO)+VALUE .GE. 0.)) GOTO 3540
                                    ENERGY(WHO) = ENERGY(WHO) - VALUE
                                    SHIELD(WHO) = SHIELD(WHO) + VALUE
                                    IF (.NOT.(VALUE.GE.0.0)) GOTO 3560
                                      DEFSHD = VALUE
3560                                CONTINUE
                                    GOTO 3550
3540                               CONTINUE
					call beeper(1)
                                    CALL MESSGE('Impossible!!')
3550                              CONTINUE
3520                            CONTINUE
C
C FLIP ENERGY NET ON OR OFF
C
                                GOTO 3510
3500                           CONTINUE
                                IF (.NOT.(COMMND .EQ. 'E ')) GOTO 3580
                                  NET(WHO) = .NOT.NET(WHO)
				If (net(who)) then
				call messge('Energy Net ON.')
				else
				call messge('Energy Net OFF.')
				endif
C
C TRACTOR BEAM
C
                                  GOTO 3590
3580                             CONTINUE
                                  IF (.NOT.(COMMND .EQ. 'B ')) GOTO 3600
                                 CALL GETINT('Ship to pull? ', II, 
     *OK, 0, 8, DEFSHP)
                                    IF (.NOT.(OK)) GOTO 3620
                                      IF (.NOT.(II .NE. 0)) GOTO 3640
                                        DEFSHP = II
3640                                  CONTINUE
                                      IF (.NOT.(II .EQ. WHO)) GOTO 3660
                                        CALL MESSGE('?Huh?')
                                        GOTO 3670
3660                                   CONTINUE
                                        TRBEAM(WHO) = II
3670                                  CONTINUE
3620                                CONTINUE
C
C     CLOAKING COMMAND
C
                                    GOTO 3610
3600                               CONTINUE
                                    IF (.NOT.(COMMND .EQ. 'F ')) GOTO 36
     *80
                                      IF (.NOT.(.NOT.CLOAK(WHO))) GOTO 3
     *700
				call messge('Now Cloaked.')
                                        CLOAK(WHO) = .TRUE.
                                        GOTO 3710
3700                                   CONTINUE
                                   CALL MESSGE('Already Cloaked!')
3710                                  CONTINUE
C
C   APPEAR COMMAND
C
                                      GOTO 3690
3680                                 CONTINUE
                                      IF (.NOT.(COMMND .EQ. 'A ')) GOTO 
     *3720
                                        IF (.NOT.(CLOAK(WHO))) GOTO 3740
				call messge('Cloaking cancelled.')
                                          CLOAK(WHO) = .FALSE.
                                          GOTO 3750
3740                                     CONTINUE
                                          CALL MESSGE('Not Cloaked!')
3750                                    CONTINUE
C
C FLIP VERBOSE MESSAGES ON OR OFF
C
                                        GOTO 3730
3720                                   CONTINUE
                                        IF (.NOT.(COMMND .EQ. 'V ')) GOT
     *O 3760
                                          VERBOS = .NOT.VERBOS
C
C     REFRESH COMMAND
C
                                          GOTO 3770
3760                                     CONTINUE
                                          IF (.NOT.(COMMND .EQ. 'R ')) G
     *OTO 3780
                                            CALL STRMOV(BLUNK2, 1, 361, 
     *OBUFF, 1)
                                            CALL RBUFF
                                            DO 3800 I = 1, 9
                                              SC(I) =  - 9999.
                                              R(I) =  - 9999.
3800                                        CONTINUE
3810                                        CONTINUE
                                            OLDSHP = 0
                                            OLDDIR =  - 1.0
	call tpos(18,75)
	ix=xcord(defshp)/10.
	iy=ycord(defshp)/10.
	encode (5,1071,mesbuf) ix,iy
	call outch(mesbuf,5)
	call tpos(17,75)
	encode(5,1081,mesbuf) edis
	call outch(mesbuf,5)
	call tpos(16,75)
	encode(5,1091,mesbuf) edir
	call outch(mesbuf,5)
	call tpos(15,79)
	encode(1,1101,mesbuf) defshp
	call outch(mesbuf,1)
	call outch(0,-1)
C
C     MESSAGE COMMAND
C
                                            GOTO 3790
3780                                       CONTINUE
                                            IF (.NOT.(COMMND .EQ. 'M '))
     *                                      GOTO 3820
                                              CALL GETINT('Uhura here,t
     *o whom? ', IVAL, OK, 0, 8, DEFSHP)
                                              IF (.NOT.(OK)) GOTO 3840
                                                IF (.NOT.(IVAL .NE. 0)) 
     *GOTO 3860
      IL = IVAL
      IH = IVAL
      GOTO 3870
3860                                             CONTINUE
      IL = 1
      IH = 8
3870                                            CONTINUE
                                                CALL TPOS(24, 1)
                                                CALL OUTCH(BLANK, 79)
                                                CALL TPOS(24, 1)
                                                CALL OUTSTR(.FALSE., 'Me
     *ssage Captain? ', .FALSE.)
                                                CALL INCHAR(MESBUF(2), 5
     *9, .TRUE.,  - 1, NC, IERR)
                                                CALL TPOS(1, 1)
                                                CALL OUTCH(0, 0)
                                                IF (.NOT.(IERR .GE. 0 .A
     *ND. NC .GT. 0))                           GOTO 3880
      MESBUF(1) = WHO + 48
      DO 3900 I = IL, IH
        IF (.NOT.(XSHIP(I))) GOTO 3920
          IF (.NOT.(I .NE. WHO)) GOTO 3940
            ENERGY(WHO) = ENERGY(WHO) - 10.
3940      CONTINUE
          CALL STRMOV(MESBUF, 1, NC + 1, MESSAG, I*60 - 59)
3920    CONTINUE
3900  CONTINUE
3910  CONTINUE
3880                                            CONTINUE
3840                                          CONTINUE
C
C     QUIT COMMAND
C
                                              GOTO 3830
3820                                         CONTINUE
                                              IF (.NOT.(COMMND .EQ. 'Q '
     *))                                      GOTO 3960
                                           CALL YESNO('Quit Now? ',
     * DONE)
C
C     HELP COMMAND
C
                                                GOTO 3970
3960                                           CONTINUE
                                                IF (.NOT.(COMMND .EQ. '?
     * '))                                      GOTO 3980
      CALL TPOS(19, 1)
	call video('1')
      CALL OUTSTR(.FALSE., 'A  Appear  B Tractor Beam   M  Send Message 
     *         T  Fire Torpedoes      ', .TRUE.)
      CALL OUTSTR(.TRUE., 'C  Course Heading           N  Freeze Anti-Ma
     *tter    W  Set Warp Speed      ', .TRUE.)
      CALL OUTSTR(.TRUE., 'F  Fade (F/A Cloak On/Off)  P  Fire Phasers  
     *        X  Detonate Anti-Matter', .TRUE.)
      CALL OUTSTR(.TRUE., 'H  Hyperspace Setting       Q  Quit          
     *        Z  Launch Anti-Matter  ', .TRUE.)
      CALL OUTSTR(.TRUE., 'K  Fire Homing Torpedo      R  Reset Display 
     *        V  Verbose On/Off      ', .TRUE.)
      CALL OUTSTR(.TRUE., 'L  Locate Ship              S  Shield Change 
     *        E  Energy Nets On/Off  ', .TRUE.)
      CALL TPOS(1, 1)
	call video('0')
      CALL OUTCH(0, 0)
      GOTO 3990
C
C    ERROR
C
3980                                             CONTINUE
      IF (.NOT.(COMMND .NE. '  ')) GOTO 4000
        CALL MESSGE('?What?')
4000  CONTINUE
3990                                            CONTINUE
3970                                          CONTINUE
3830                                        CONTINUE
3790                                      CONTINUE
3770                                    CONTINUE
3730                                  CONTINUE
3690                                CONTINUE
3610                              CONTINUE
3590                            CONTINUE
3510                          CONTINUE
3470                        CONTINUE
3390                      CONTINUE
3350                    CONTINUE
3310                  CONTINUE
3250                CONTINUE
3210              CONTINUE
3090            CONTINUE
3010          CONTINUE
2890        CONTINUE
2670      CONTINUE
2650    CONTINUE
        IF (.NOT.((XSHIP(WHO) .AND. REFTOG) .OR. REFRES)) GOTO 4020
          CALL REFRSH(SC, R, WHO)
4020    CONTINUE
        IF (.NOT.(REFRES)) GOTO 4040
          XSHIP(WHO) = .TRUE.
          REFRES = .FALSE.
          REFTOG = .FALSE.
C
C      WRITE OUT MESSAGES FROM DRIVER
C
4040    CONTINUE
        DO 4060 I = 1, 10
          IF (.NOT.(ISENT(WHO, I) .NE. 0)) GOTO 4080
            J = ISENT(WHO, I)
            ISENT(WHO, I) = 0
            GO TO(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
     * 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 3
     *3, 34, 35, 36), J
1           CONTINUE
		call beeper(1)
            CALL MESSGE('Docked.')
            GOTO 4060
2           CONTINUE
		call beeper(1)
            CALL MESSGE('Hit a Star!')
            GOTO 4060
3           CONTINUE
            DO 4100 IK = 1, 3
              CALL CLEAR
	call video('0')
	call video('l')
              CALL OUTCH(0, 0)
	call wait(20,1,m)
		call beeper(1)
		call beeper(1)
		call beeper(1)
	call tpos(12,30)
	call outstr(.false.,'<<< K A B O O M >>>',.false.)
	call video('h')
	call wait(20,1,m)
4100        CONTINUE
4110        CONTINUE
	call purge
	call clear
	call tpos(10,1)
	call outch(0,0)
            WRITE(5, 1141) 
1141        FORMAT('0Your Ship has been destroyed!'/, ' Fortunately you 
     *escaped with your life.'/, ' Unfortunately, You have been given a 
     *new Command.'//, '$Are you ready to accept this assignment? ')
            CALL YESNO(0, YES)
            IF (.NOT.(YES)) GOTO 4120
	write (5,1142)
1142	format(' Ata Boy! Good for you.')
	call wait(45,1,m)
              CALL STRMOV(BLUNK2, 1, 361, OBUFF, 1)
              CALL RBUFF
              DO 4140 K = 1, 9
                SC(K) =  - 9999.
                R(K) =  - 9999.
4140          CONTINUE
4150          CONTINUE
              OLDDIR =  - 1.0
              OLDSHP = 0
              REFRES = .TRUE.
              GOTO 4130
4120         CONTINUE
              DONE = .TRUE.
4130        CONTINUE
	busy(who)=.false.
            GOTO 4060
4           CONTINUE
		call beeper(2)
            CALL MESSGE('Torpedo hit us!')
            GOTO 4060
5           CONTINUE
		call beeper(1)
            CALL MESSGE('Torpedo hit Alien!')
            GOTO 4060
6           CONTINUE
		call beeper(1)
            CALL MESSGE('Phaser hit Alien!')
            GOTO 4060
7           CONTINUE
		call beeper(1)
            CALL MESSGE('Phaser hit Torpedo!')
            GOTO 4060
8           CONTINUE
		call beeper(1)
            CALL MESSGE('Phasers missed.')
            GOTO 4060
9           CONTINUE
		call beeper(3)
            CALL MESSGE('Rammed Alien!')
            GOTO 4060
10          CONTINUE
		call beeper(2)
            CALL MESSGE('Collision!')
            GOTO 4060
11          CONTINUE
		call beeper(1)
            CALL MESSGE('Phaser hit Star!')
            GOTO 4060
12          CONTINUE
		call beeper(2)
            CALL MESSGE('Base under attack!')
            GOTO 4060
13          CONTINUE
		call beeper(1)
            CALL MESSGE('Torpedo hit Star!')
            GOTO 4060
14          CONTINUE
		call beeper(2)
            CALL MESSGE('Phaser attack!')
            GOTO 4060
15          CONTINUE
		call clear
            CALL TPOS(18, 1)
            CALL OUTSTR(.FALSE., 'Spock here Captain.     ', .TRUE.)
            CALL OUTSTR(.TRUE., 'We are being drawn into some sort of bl
     *ack hole,', .TRUE.)
            CALL OUTSTR(.TRUE., 'It is unlike anything I have ever encou
     *ntered.', .TRUE.)
            CALL OUTSTR(.TRUE., 'Fascinating!!!', .TRUE.)
            CALL WAIT(1, 2, M)
            GOTO 4060
16          CONTINUE
		call clear
            CALL TPOS(18, 1)
            CALL OUTSTR(.FALSE., 'Scott here Captain.     ', .TRUE.)
          CALL OUTSTR(.TRUE., 'Our Dylithium crystals are gone.',.TRUE.)
            CALL OUTSTR(.TRUE., 'Life support is failing!!!', .TRUE.)
            CALL WAIT(1, 2, M)
            GOTO 4060
17          CONTINUE
		call beeper(1)
            CALL MESSGE('Hyperspace!')
            GOTO 4060
18          CONTINUE
		call beeper(1)
            CALL MESSGE('Hyperspace blocked!')
            GOTO 4060
19          CONTINUE
		call beeper(1)
            CALL MESSGE('Random Hyperspace!')
            GOTO 4060
20          CONTINUE
		call beeper(1)
            CALL MESSGE('Torpedo hit Torpedo!')
            GOTO 4060
21          CONTINUE
		call beeper(1)
            CALL MESSGE('Hit Ghost Ship!')
            GOTO 4060
22          CONTINUE
		call beeper(5)
            CALL MESSGE('**ALIEN DESTROYED**')
            GOTO 4060
23          CONTINUE
		call beeper(1)
            CALL MESSGE('Pod blocked!')
            GOTO 4060
24          CONTINUE
		call beeper(1)
            CALL MESSGE('Pod destroyed!')
            GOTO 4060
25          CONTINUE
		call beeper(1)
            CALL MESSGE('Phaser hit Pod!')
            GOTO 4060
26          CONTINUE
		call beeper(1)
            CALL MESSGE('Torpedo hit Pod!')
            GOTO 4060
27          CONTINUE
		call beeper(2)
            CALL MESSGE('Metal object near.')
            GOTO 4060
28          CONTINUE
		call beeper(1)
            CALL MESSGE('Pod launched.')
            GOTO 4060
29          CONTINUE
		call beeper(1)
            CALL MESSGE('Pod detonated!')
            GOTO 4060
30          CONTINUE
		call beeper(1)
            CALL MESSGE('Pod explosion!')
            GOTO 4060
31          CONTINUE
		call beeper(2)
            CALL MESSGE('Zowieeee!')
            GOTO 4060
32          CONTINUE
		call beeper(1)
            CALL MESSGE('Pod hit Alien!')
            GOTO 4060
33          CONTINUE
		call beeper(1)
            CALL MESSGE('Hit Net!')
            GOTO 4060
34          CONTINUE
		call beeper(1)
            CALL MESSGE('Torpedo hit Net!')
            GOTO 4060
35          CONTINUE
		call beeper(1)
            CALL MESSGE('Phaser hit Net!')
            GOTO 4060
36          CONTINUE
		call beeper(1)
            CALL MESSGE('Net blocked!')
            GOTO 4060
4080      CONTINUE
4060    CONTINUE
4070    CONTINUE
        IF (.NOT.(MESSAG(WHO*60-59) .NE. ' ')) GOTO 4160
          CALL TPOS(24, 1)
		call beeper(1)
	call video('7')
          CALL OUTCH('Message from Ship ', 18)
          MIND = WHO*60 - 59
          CALL OUTCH(MESSAG(MIND), 1)
          CALL OUTCH(' - ', 3)
          CALL OUTCH(MESSAG(MIND + 1), 57)
          CALL TPOS(1, 1)
          CALL OUTCH(0, 0)
	call video('0')
          CALL STRMOV(BLANK, 1, 60, MESSAG, MIND)
4160    CONTINUE
        IF (.NOT.((ENERGY(WHO) .LT. 900.) .AND. WARN)) GOTO 4180
		call beeper(1)
          CALL MESSGE('Energy low!')
          WARN = .FALSE.
          GOTO 4190
4180     CONTINUE
          WARN = .TRUE.
4190    CONTINUE
        CALL MESSGE(0)
	IF (.NOT.(DONE)) GOTO 2150
2170  CONTINUE
      CREW(WHO) = CREW(WHO) - 1
      IF (.NOT.(CREW(WHO) .LE. 400)) GOTO 4200
        XSHIP(WHO) = .FALSE.
        GOTO 4210
4200   CONTINUE
        XSHIP(WHO) = .TRUE.
4210  CONTINUE
      CALL CLEAR
	call video('1')
      CALL OUTCH(0, 0)
	call time(timbf)
	write(5,3341)timbf
3341	format(' Mission ending at Stardate ',a8)
	call video('0')
	If (share(who) .eq. 1) share(who)=0
	If (.not.(yesshr)) share(who)=0
      CALL EXIT
      END
      SUBROUTINE TREAD(STR, NC)
      BYTE STR
      CALL INCHAR(STR, NC, .FALSE., 0, NC, IERR)
      IF (.NOT.(NC .EQ. 0 .AND. IERR .NE. -2)) GOTO 4220
        STR = ' '
        GOTO 4230
4220   CONTINUE
        IF (.NOT.(STR .GE. 'a' .AND. STR .LE. 'z')) GOTO 4240
          STR = (STR - 'a') + 'A'
4240    CONTINUE
4230  CONTINUE
      RETURN
      END
      SUBROUTINE RBUFF
      COMMON/MESS/CLEARF
	common/local/shrflg(8)
	integer shrflg
      LOGICAL CLEARF
	do 111, ixx=1,8
	shrflg(ixx)=0
111	continue
      CALL CLEAR
      CLEARF = .FALSE.
C
C     DRAW NEW SCREEN
C
	call video('1')
	call buffil(1, 5, 'Ship Parameters', 15)
	call video('0')
      CALL BUFFIL(2, 4, 'Energy   :', 10)
      CALL BUFFIL(3, 4, 'Shields  :', 10)
      CALL BUFFIL(5, 4, 'Warp     :', 10)
      CALL BUFFIL(6, 4, 'Course   :', 10)
      CALL BUFFIL(8, 4, 'X co-ord :', 10)
      CALL BUFFIL(9, 4, 'Y co-ord :', 10)
      CALL BUFFIL(11, 4, 'Torps    :', 10)
      CALL BUFFIL(12, 4, 'Seekers  :', 10)
      CALL BUFFIL(13, 4, 'Hyper    :', 10)
      CALL BUFFIL(15, 4, 'Def Ship :', 10)
      CALL BUFFIL(16, 4, 'Def Direc:', 10)
	call video('1')
      CALL BUFFIL(1, 68, 'Player Scores', 13)
	call video('0')
      CALL BUFFIL(2, 69, '1', 1)
      CALL BUFFIL(3, 69, '2', 1)
      CALL BUFFIL(4, 69, '3', 1)
      CALL BUFFIL(5, 69, '4', 1)
      CALL BUFFIL(6, 69, '5', 1)
      CALL BUFFIL(7, 69, '6', 1)
      CALL BUFFIL(8, 69, '7', 1)
      CALL BUFFIL(9, 69, '8', 1)
	call video('1')
	call buffil(14, 68, 'Range Finder', 12)
	call video('0')
      CALL BUFFIL(15, 69, 'Scan:', 5)
      CALL BUFFIL(16, 69, 'Dir :', 5)
      CALL BUFFIL(17, 69, 'Dist:', 5)
      CALL BUFFIL(18, 69, 'Sect:', 5)
	call video('1')
	call buffil(11, 70, 'StarDate', 8)
	call video('0')
      CALL OUTCH(0, 0)
	call video('7')
	call video(' ')
	call video('0')
	call outch(0,0)
      RETURN
      END
      SUBROUTINE GETREL(PROMPT, V, EXIST, LOW, HIGH, DEFVAL)
      LOGICAL*1EXIST, OK
      REAL V, LOW, HIGH, DEFVAL
      BYTE INPUT(15)
      INTEGER NCHRS
      EXIST = .FALSE.
      CALL REDPMT(PROMPT, INPUT, 15, NCHRS)
      IF (.NOT.(NCHRS .EQ. 0)) GOTO 4260
        V = DEFVAL
        EXIST = .TRUE.
        GOTO 4270
4260   CONTINUE
        IF (.NOT.(NCHRS .LT. 0)) GOTO 4280
          EXIST = .FALSE.
          GOTO 4290
4280     CONTINUE
          IF (.NOT.(NCHRS .LE. 15)) GOTO 4300
            DECODE(NCHRS, 1001, INPUT, ERR=201) V
1001        FORMAT(G15.0)
            IF (.NOT.(V .GE. LOW .AND. V .LE. HIGH)) GOTO 4320
              EXIST = .TRUE.
              GOTO 4330
4320         CONTINUE
201           CONTINUE
		call beeper(1)
			call video('7')
              CALL MESSGE('?Range Error?')
			call video('0')
4330        CONTINUE
4300      CONTINUE
4290    CONTINUE
4270  CONTINUE
      RETURN
      END
      SUBROUTINE REFRSH(SC, R, I)
C     TEXT COMMON
      COMMON/TORPE/TLOCS(8, 10, 2), TDIR(8, 10), IT(8)
      COMMON/LEDFOR/ENERGY(8), SHIELD(8), XCORD(8), YCORD(8), TORPS(8), 
     *HX, HY, HW, CDRAIN, NDRAIN, TDRAIN, SCAN(8), PHA(8), I1, I2, HYPER
     *(8), ISENT(8, 10), XPOD(8), YPOD(8), DPOD(8), IPOD(8), WPOD(8), XH
     *OM(8, 4), YHOM(8, 4), WHOM(8, 4), NHOM(8), TRBEAM(8), SCORE(8), CR
     *EW(8), DIR(8), WARP(8), LAUNCH(8), UNIV(100, 100), MESSAG(480), TH
     *RU, XSHIP(8), CLOAK(8), NET(8), BHOLE, EMPTY
      REAL LAUNCH, NDRAIN
      INTEGER SCAN, WHOM, CREW, HYPER, TORPS, TRBEAM
      LOGICAL*1THRU, XSHIP, CLOAK, NET
C NOTE: BHOLE AND EMPTY ARE THE CHARACTERS FOR THE BLACK HOLE
C       AND EMPTY SPACE AND ARE SET IN MTREKINI.
      BYTE UNIV, MESSAG, BHOLE, EMPTY
C     END COMMON
	common/me/who
	integer who
      REAL SC(8), R(9)
      BYTE STRNG(10)
      BYTE ACT(8)
      INTEGER DEFSHP, OLDSHP
      REAL DEFDIR, OLDDIR
      COMMON/DEFLTS/DEFSHP, DEFDIR, OLDDIR, OLDSHP
      DATA ACT/8*' '/, OLDSHP/0/, OLDDIR/ - 1.0/
      IF (.NOT.(R(1) .NE. ENERGY(I))) GOTO 4340
        R(1) = ENERGY(I)
        ENCODE(7, 1001, STRNG) R(1)
1001    FORMAT(F7.1)
	If (energy(i) .le. 2500) then
	call video('5')
	else
	call video('7')
	endif
        CALL BUFFIL(2, 15, STRNG, 7)
	call video('0')
4340  CONTINUE
      IF (.NOT.(R(2) .NE. SHIELD(I))) GOTO 4360
        R(2) = SHIELD(I)
        ENCODE(7, 1011, STRNG) R(2)
1011    FORMAT(F7.1)
        CALL BUFFIL(3, 15, STRNG, 7)
4360  CONTINUE
      IF (.NOT.(R(3) .NE. WARP(I))) GOTO 4380
        R(3) = WARP(I)
        ENCODE(4, 1021, STRNG) R(3)
1021    FORMAT(F4.2)
        CALL BUFFIL(5, 18, STRNG, 4)
4380  CONTINUE
      IF (.NOT.(R(4) .NE. DIR(I))) GOTO 4400
        R(4) = DIR(I)
        IF (.NOT.(R(4) .GT. 90.)) GOTO 4420
          V = (450. - R(4))/30.
          GOTO 4430
4420     CONTINUE
          V = (90. - R(4))/30.
4430    CONTINUE
        ENCODE(5, 1031, STRNG) V
1031    FORMAT(F5.2)
        CALL BUFFIL(6, 17, STRNG, 5)
4400  CONTINUE
      IF (.NOT.(R(5) .NE. XCORD(I))) GOTO 4440
        R(5) = XCORD(I)
        ENCODE(5, 1041, STRNG) R(5)
1041    FORMAT(F5.1)
        CALL BUFFIL(8, 17, STRNG, 5)
4440  CONTINUE
      IF (.NOT.(R(6) .NE. YCORD(I))) GOTO 4460
        R(6) = YCORD(I)
        ENCODE(5, 1051, STRNG) R(6)
1051    FORMAT(F5.1)
        CALL BUFFIL(9, 17, STRNG, 5)
4460  CONTINUE
      IR = R(7)
      IF (.NOT.(IR .NE. TORPS(I))) GOTO 4480
        R(7) = TORPS(I)
        ENCODE(2, 1061, STRNG) TORPS(I)
1061    FORMAT(I2)
	If (torps(i) .le. 4) then
	call video('5')
	else
	call video('1')
	endif
        CALL BUFFIL(11, 20, STRNG, 2)
	call video('0')
4480  CONTINUE
      IR = R(8)
      IF (.NOT.(IR .NE. NHOM(I))) GOTO 4500
        R(8) = NHOM(I)
        ENCODE(2, 1071, STRNG) NHOM(I)
1071    FORMAT(I2)
	If (nhom(i) .le. 2) then
	call video('5')
	else
	call video('7')
	endif
        CALL BUFFIL(12, 20, STRNG, 2)
	call video('0')
4500  CONTINUE
      IR = R(9)
      IF (.NOT.(IR .NE. HYPER(I))) GOTO 4520
        R(9) = HYPER(I)
        ENCODE(1, 1081, STRNG) HYPER(I)
1081    FORMAT(I1)
        CALL BUFFIL(13, 21, STRNG, 1)
4520  CONTINUE
      IF (.NOT.(OLDSHP .NE. DEFSHP)) GOTO 4540
        OLDSHP = DEFSHP
        ENCODE(1, 1091, STRNG) OLDSHP
1091    FORMAT(I1)
        CALL BUFFIL(15, 21, STRNG, 1)
4540  CONTINUE
      IF (.NOT.(OLDDIR .NE. DEFDIR)) GOTO 4560
        OLDDIR = DEFDIR
        ENCODE(5, 1101, STRNG) DEFDIR
1101    FORMAT(F5.2)
        CALL BUFFIL(16, 17, STRNG, 5)
4560  CONTINUE
      DO 4580 J = 1, 8
        IF (.NOT.((SC(J) .NE. SCORE(J)) .OR. (XSHIP(J).XOR.(ACT(J) .EQ. 
     *'*')))) GOTO 4600
          IF (.NOT.(XSHIP(J))) GOTO 4620
            ACT(J) = '*'
            GOTO 4630
4620       CONTINUE
            ACT(J) = ' '
4630      CONTINUE
          SC(J) = SCORE(J)
          ENCODE(10, 1111, STRNG) SC(J), ACT(J)
1111      FORMAT(F8.0, 1X, A1)
	If (who .eq. j) then
	call video('7')
	endif
          CALL BUFFIL(J + 1, 71, STRNG, 10)
	If (who .eq. j) then
	call video('0')
	call outch(0,0)
	endif
4600    CONTINUE
4580  CONTINUE
4590  CONTINUE
      CALL OUTCH(0,  - 1)
      RETURN
      END
      SUBROUTINE BUFFIL(IY, IX, ST, L)
      BYTE ST(1)
      CALL TPOS(IY, IX)
      CALL OUTCH(ST, L)
      RETURN
      END
      SUBROUTINE GETINT(PROMPT, N, FLAG, LOW, HIGH, DEFVAL)
      INTEGER N, LOW, HIGH, DEFVAL
      LOGICAL*1OK, FLAG
      BYTE INPUT(15)
      FLAG = .FALSE.
      CALL REDPMT(PROMPT, INPUT, 15, NCHRS)
      IF (.NOT.(NCHRS .LT. 0)) GOTO 4640
        FLAG = .FALSE.
        GOTO 4650
4640   CONTINUE
        IF (.NOT.(NCHRS .EQ. 0)) GOTO 4660
          FLAG = .TRUE.
          N = DEFVAL
          GOTO 4670
4660     CONTINUE
          DECODE(NCHRS, 1011, INPUT, ERR=201) N
1011      FORMAT(I5)
          IF (.NOT.((N .GE. LOW) .AND. (N .LE. HIGH))) GOTO 4680
            FLAG = .TRUE.
            GOTO 4690
4680       CONTINUE
201         CONTINUE
		call beeper(1)
			call video('7')
            CALL MESSGE('?Range Error?')
			call video('0')
4690      CONTINUE
4670    CONTINUE
4650  CONTINUE
      RETURN
      END
      SUBROUTINE REDPMT(PROMPT, INPUT, NINPUT, NCHRS)
C
C  DO A READ WITHOUT PROMPT AND WITHOUT ECHO; IF NO INPUT IS RECEIVED AFTER 1/2
C  SECOND, ISSUE THE PROMPT, THEN READ WITH NO TIMEOUT AND WITH ECHO.
C  IF A PROMPT IS ISSUED, IT AND THE INPUT IS ERASED TO BLANKS AFTER
C  THE READ.
C
C  THIS ROUTINE COULD DO A SIMPLE PROMPT AND READ AFTER POSITIONING
C  TO (PRMPTY, PRMPTX), FOLLOWED BY ERASING THE PROMPT AND INPUT
C  TO BLANKS, IF NECCESSARY ON YOUR SYSTEM.
C
      IMPLICIT INTEGER(A - Z)
      PARAMETER MAXPRM = 20
      PARAMETER PRMPTY = 18, PRMPTX = 4, PRMPTL = 21, CR = 13
      BYTE PROMPT(1), INPUT(NINPUT), BLANKS(PRMPTL)
      LOGICAL ECHO
      DATA BLANKS/PRMPTL*' '/
      NCHRS = 0
      ECHO = .TRUE.
      IF (.NOT.(PROMPT(1) .NE. 0)) GOTO 4700
C IF PROMPT IS NOT NULL...
C GET TYPE AHEAD
        CALL INCHAR(INPUT, NINPUT, .FALSE., 0, NC, IERR)
        IF (.NOT.(IERR .EQ. -1)) GOTO 4720
C EOF?
          GO TO 999
4720    CONTINUE
        NCHRS = NCHRS + NC
        IF (.NOT.(IERR .EQ. CR)) GOTO 4740
C DONE?
          RETURN
4740    CONTINUE
C WAIT 1/2 SEC, THEN READ AGAIN
        CALL WAIT(30, 0, DSW)
        CALL INCHAR(INPUT(NCHRS + 1), NINPUT - NCHRS, .FALSE., 0, NC, IE
     *RR)
        IF (.NOT.(IERR .EQ. -1)) GOTO 4760
C EOF?
          GO TO 999
4760    CONTINUE
        NCHRS = NCHRS + NC
        IF (.NOT.(IERR .EQ. CR)) GOTO 4780
C DONE?
          RETURN
4780    CONTINUE
        IF (.NOT.(NCHRS .EQ. 0)) GOTO 4800
C THEN ISSUE PROMPT
          LEN = 1
4820      IF (.NOT.(LEN .LE. MAXPRM .AND. PROMPT(LEN) .NE. 0)) GOTO 4840
4830        LEN = LEN + 1
            GOTO 4820
4840      CONTINUE
          CALL TPOS(PRMPTY, PRMPTX)
	call video('1')
          CALL OUTCH(PROMPT, LEN - 1)
	call video('0')
          GOTO 4810
4800     CONTINUE
          ECHO = .FALSE.
4810    CONTINUE
4700  CONTINUE
      CALL INCHAR(INPUT(NCHRS + 1), NINPUT - NCHRS, ECHO,  - 1, NC, IERR
C FINAL READ
     *)
      IF (.NOT.(PROMPT(1) .NE. 0 .AND. NCHRS .EQ. 0)) GOTO 4850
C THEN ERASE PROMPT STRNG
        CALL TPOS(PRMPTY, PRMPTX)
        CALL OUTCH(BLANKS, PRMPTL)
4850  CONTINUE
      IF (.NOT.(IERR .EQ. -1)) GOTO 4870
C EOF?
        GO TO 999
4870  CONTINUE
      NCHRS = NCHRS + NC
      RETURN
999   CONTINUE
      NCHRS =  - 1
      RETURN
      END
      SUBROUTINE YESNO(PROMPT, FLAG)
      LOGICAL*1FLAG, OK
      BYTE PROMPT(1)
      BYTE ANSWER(4)
C
      OK = .FALSE.
      ANSWER(1) = 0
      CALL REDPMT(PROMPT, ANSWER, 4, NCHRS)
4890  CONTINUE
        IF (.NOT.(NCHRS .LE. 0)) GOTO 4920
          NCHRS = 1
          ANSWER(1) = 0
4920    CONTINUE
        IF (.NOT.(ANSWER(1) .GE. 'a' .AND. ANSWER(1) .LE. 'z')) GOTO 494
     *0
          ANSWER(1) = (ANSWER(1) - 'a') + 'A'
C     * CHECK FOR YES
4940    CONTINUE
        IF (.NOT.(ANSWER(1) .EQ. 'Y')) GOTO 4960
          FLAG = .TRUE.
          OK = .TRUE.
C     * CHECK FOR A NO
          GOTO 4970
4960     CONTINUE
          IF (.NOT.(ANSWER(1) .EQ. 'N')) GOTO 4980
            FLAG = .FALSE.
            OK = .TRUE.
C     * INCORRECT RESPONSE
            GOTO 4990
4980       CONTINUE
            IF (.NOT.(PROMPT(1) .EQ. 0)) GOTO 5000
              CALL OUTCH(13, 1)
              CALL OUTSTR(.TRUE., 'Answer Yes or No? ', .FALSE.)
              CALL INCHAR(ANSWER, 3, .TRUE.,  - 1, NCHRS, IER)
              GOTO 5010
5000         CONTINUE
              CALL REDPMT('Answer Yes or No? ', ANSWER, 3, NCHRS)
5010        CONTINUE
4990      CONTINUE
4970    CONTINUE
4900    IF (.NOT.(OK)) GOTO 4890
4910  CONTINUE
      RETURN
      END
      SUBROUTINE OUTSTR(LFFLAG, STRNG, CRFLAG)
      LOGICAL LFFLAG, CRFLAG
      BYTE STRNG(1)
      LEN = 0
5020  IF (.NOT.(STRNG(LEN+1) .NE. 0)) GOTO 5040
5030    LEN = LEN + 1
        GOTO 5020
5040  CONTINUE
      IF (.NOT.(LFFLAG)) GOTO 5050
        CALL OUTCH(10, 1)
5050  CONTINUE
      CALL OUTCH(STRNG, LEN)
      IF (.NOT.(CRFLAG)) GOTO 5070
        CALL OUTCH(0,  - 1)
        GOTO 5080
5070   CONTINUE
        CALL OUTCH(0, 0)
5080  CONTINUE
      RETURN
      END
      SUBROUTINE BNDRY(IXLOW, IXHI, IYLOW, IYHI)
C     TEXT COMMON
      COMMON/TORPE/TLOCS(8, 10, 2), TDIR(8, 10), IT(8)
      COMMON/LEDFOR/ENERGY(8), SHIELD(8), XCORD(8), YCORD(8), TORPS(8), 
     *HX, HY, HW, CDRAIN, NDRAIN, TDRAIN, SCAN(8), PHA(8), I1, I2, HYPER
     *(8), ISENT(8, 10), XPOD(8), YPOD(8), DPOD(8), IPOD(8), WPOD(8), XH
     *OM(8, 4), YHOM(8, 4), WHOM(8, 4), NHOM(8), TRBEAM(8), SCORE(8), CR
     *EW(8), DIR(8), WARP(8), LAUNCH(8), UNIV(100, 100), MESSAG(480), TH
     *RU, XSHIP(8), CLOAK(8), NET(8), BHOLE, EMPTY
      REAL LAUNCH, NDRAIN
      INTEGER SCAN, WHOM, CREW, HYPER, TORPS, TRBEAM
      LOGICAL*1THRU, XSHIP, CLOAK, NET
C NOTE: BHOLE AND EMPTY ARE THE CHARACTERS FOR THE BLACK HOLE
C       AND EMPTY SPACE AND ARE SET IN MTREKINI.
      BYTE UNIV, MESSAG, BHOLE, EMPTY
C     END COMMON
      BYTE ALPHA
      BYTE JUNK, NBUFF
      COMMON/BNDRY/IXX, IYY, ID, MINID8, JUNK, NBUFF( - 9: + 9,  - 9: + 
     *9)
      DO 5090 IX1 = IXLOW, IXHI
        IX = IX1 - IXX
        DO 5110 IY1 = IYLOW, IYHI
          IY = IY1 - IYY
          ALPHA = UNIV(IX1, IY1)
          IF (.NOT.(ALPHA .EQ. EMPTY)) GOTO 5130
            IF (.NOT.(((IX .EQ. -ID .OR. IX .EQ. ID .OR. IX .EQ. 0) .AND
     *. (IY1 .EQ. 100 .OR. IY1 .EQ. 1)) .OR. ((IY .EQ. -ID .OR. IY .EQ. 
     *MINID8 .OR. IY .EQ. 0) .AND. (IX1 .EQ. 100 .OR. IX1 .EQ. 1)))) GOT
     *O 5150
              NBUFF(IX, IY) = '-'
5150        CONTINUE
            GOTO 5140
5130       CONTINUE
            IF (.NOT.((ALPHA .GE. 48+1) .AND. (ALPHA .LE. 48+8) .AND. (C
     *LOAK(ALPHA-48)))) GOTO 5170
              NBUFF(IX, IY) = EMPTY
              GOTO 5180
5170         CONTINUE
              IF (.NOT.(ALPHA .LT. 0)) GOTO 5190
                NBUFF(IX, IY) = '%'
                GOTO 5200
5190           CONTINUE
                NBUFF(IX, IY) = ALPHA
5200          CONTINUE
5180        CONTINUE
5140      CONTINUE
5110    CONTINUE
5120    CONTINUE
5090  CONTINUE
5100  CONTINUE
      RETURN
      END
	Subroutine beeper(I)

	common/silent/belflg
	logical*1 belflg
	Integer I
	Character*1 Bell
	Data Bell /7/

	If (.not.(belflg)) then
	Do 1	IX = 1,I
	write	(5,9999) Bell
9999	format	('+',a)
1	continue
	endif

	Return
	End

	Subroutine Video(Attr)

	byte Attr
	common/cursor/ttype
	Integer ttype
	parameter vt100=2
	byte esc
	data esc /27/

	If (ttype .ne. vt100) goto 2
		If (Attr .eq. ' ') goto 3
		call outch(esc,1)
	If (Attr .eq. '<') goto 4
		call outch('[',1)
		If (Attr .eq. 'l' .or. Attr .eq. 'h') goto 1
		call outch(Attr,1)
		call outch('m',1)
		call outch(0,0)
		goto 2
3	do 4444 iv=1,18
		call tpos(iv,25)
			do 5555 iu=1,37
				call outch(' ',1)
5555			continue
4444	continue
	call outch(0,0)
		goto 2
1		call outch('?',1)
		call outch('5',1)
4		call outch(Attr,1)
		call outch(0,0)
2	return
	end

	subroutine respnd(prompt,answer)
	character*1 answ
	character*80 prompt
	logical*1 answer

	ik=index(prompt,'?')
	If (ik .eq. 0) ik=79
	write (5,1)prompt(1:ik+1)
1	format('$',a)
	read (5,2,end=3)answ
2	format(1a1)
3	If (answ .eq. 'Y' .or. answ .eq. 'y') then
	answer = .true.
	else
	answer = .false.
	endif

	return
	end
