$	vflg = 'f$verify(0)
$	set noon
$	if p2 .eqs. "" then goto no_output
$ ! get length of the first parameter
$	fsl = 'f$length(p1)'
$ ! now see if "dev:" or "[dir]" appear in the first parameter
$	dend  = 'f$locate("]",p1)' + 1
$	dvend = 'f$locate(":",p1)' + 1
$	if dend  .gt. fsl then dend = 0
$	if dvend .gt. fsl then dvend = 0
$	if dvend .gt. dend then dend = dvend
$	dirdev := 'f$extract(0,dend,p1)'
$ ! default the file type for the .sho file
$	fn := 'f$extract(dend,fsl,p1)'
$	ft = 'f$locate(".",fn)'
$	if ft .eq. 'f$length(fn)' then p1 := 'p1'.sho
$ ! put a sorted list of pictures into sys$login:copyshow.tmp 
$	assign/user nl: sys$output	! get rid of "sort statistics"
$	sort/key=(pos=1,size=40) 'p1' sys$login:copyshow.tmp
$ ! close the file if it is already open
$	if "''f$logical(""FILELIST"")" .nes. ""	then close FILELIST
$ ! open the .sho file for input
$	open/err=open_err FILELIST sys$login:copyshow.tmp
$ ! copy each .pic file referenced
$	lastfile :=
$ loop:
$		read/end=endfile FILELIST name
$		f := 'f$extract(0,1,name)'
$	! dont copy if this is an embedded command
$		if f .eqs. "+" .or. f .eqs. "*" then goto loop
$	! remove object name, if any, from slide name
$		t = 'f$locate(" ",name)'
$		name := 'f$extract(0,t,name)'
$	! get length of the name
$		fsl = 'f$length(name)'
$	! now see if "dev:" or "[dir]" appear in the name
$		dend  = 'f$locate("]",name)' + 1
$		dvend = 'f$locate(":",name)' + 1
$		if dend  .gt. fsl then dend = 0
$		if dvend .gt. fsl then dvend = 0
$		if dvend .gt. dend then dend = dvend
$	! default the file type for the .pic file
$		fn := 'f$extract(dend,fsl,name)'
$		ft = 'f$locate(".",fn)'
$		if ft .eq. 'f$length(fn)' then name := 'name'.pic
$		if dend .eq. 0 then name := 'dirdev''name'
$	! dont copy same file twice
$		if name .eqs. lastfile then goto loop
$		copy 'name' 'p2'
$		lastfile := 'name'
$		goto loop
$ !
$ endfile:
$	close FILELIST
$	delete sys$login:copyshow.tmp.*
$ ! copy the .sho file
$	copy 'p1' 'p2'
$	if vflg .eq 1 then set verify
$	exit
$ open_err:
$	write sys$output "COPYSHOW ERROR -- could not open file ''p1'"
$	if vflg .eq 1 then set verify
$	exit
$ no_output:
$	write sys$output "COPYSHOW ERROR -- destination not specified"
$	if vflg .eq 1 then set verify
