	CHARACTER*7 FUNCTION DEVICE
C
C
C		AUTHOR:	JOE NUNNELLEY.
C			LOUISVILLE GAS & ELECTRIC CO.
C			P.O. BOX 32020
C			731 W. ORMSBY ST.
C			LOUISVILLE, KY 40232
C
C		DATE:	12/16/80
C
C		DESCRIPTION:	
C			GET TERMINAL CHARACTERISTICS IN CHARACTER FORM
C
C
C
C
	IMPLICIT INTEGER*4 (A-Z)
	EXTERNAL	TT$_FT2
	EXTERNAL	TT$_VT100
	EXTERNAL	TT$_VT52
	EXTERNAL	TT$_VT05
	EXTERNAL	TT$_LA36
	EXTERNAL	TT$_LA120
	EXTERNAL	TT$_UNKNOWN
	EXTERNAL	TT$_FT3
	EXTERNAL	TT$_FT4
	EXTERNAL	TT$_FT5
	EXTERNAL	TT$_FT6
	EXTERNAL	TT$_FT7
	EXTERNAL	TT$_FT1
C	INCLUDE		'GETDEV.INC/NOLIST'
	INTEGER*4 PRI_WORD(64),BB(20)
	CHARACTER*256	ERROR*256,PRIBUF,OUTPUT*20,CONSTANT*10
	DATA	CONSTANT	/'SYS$OUTPUT'/
C
C
C		TRANSLATE (ONCE) TO SEE WHAT WE ARE.
C
	DSW=SYS$TRNLOG(CONSTANT,OUTLEN,OUTPUT,,,)
	IF(.NOT.DSW) THEN		! ERROR ON TRANSLATE
		DSW1=SYS$GETMSG(%VAL(DSW),LENG,ERROR,%VAL(15),)
C
C
C			PRINT AN ENGLISH ERROR MESSAGE
C
		PRINT 101,ERROR(:LENG),OUTPUT,OUTLEN
101		FORMAT(1X,A/1X,A,I10)
		DEVICE='BADTRAN'
		RETURN
	   ENDIF
C
C
C		THE TRANSLATE GIVES "33 & 3CHARS IF IT IS A PROCESS PERM FILE
C
	I=1
	IF(ICHAR(OUTPUT(I:I)).EQ."33) I=5
C
C
C		GET THE DEVICE CHAR...
C
3	DSW=SYS$GETDEV(OUTPUT(I:OUTLEN),PRILEN,PRIBUF,,)
	IF(.NOT.DSW) THEN		! ERROR
		DSW1=SYS$GETMSG(%VAL(DSW),LENG,ERROR,%VAL(15),)
		PRINT 101,ERROR(:LENG)
		DEVICE='BADGETD'
		RETURN
	   ENDIF
C
C		CONVERT THE CHAR DATA TO LONG_WORDS
C
	DO 1 I=1,PRILEN
1	PRI_WORD(I)= ICHAR(PRIBUF(I:I))
C
C
C
C		RETURN IT LIKE WE WANT IT
C
	TST=PRI_WORD(DIB$B_DEVTYPE+1)
	DEVICE='UNKNOWN'
	IF(TST.EQ.%LOC(TT$_FT1))	DEVICE='VT100'
	IF(TST.EQ.%LOC(TT$_FT2))	DEVICE='ADM3A'
	IF(TST.EQ.%LOC(TT$_VT100))	DEVICE='VT100'
	IF(TST.EQ.%LOC(TT$_VT52))	DEVICE='VT52'
	IF(TST.EQ.%LOC(TT$_VT05))	DEVICE='VT05'
	IF(TST.EQ.%LOC(TT$_LA36))	DEVICE='LA36'
	IF(TST.EQ.%LOC(TT$_LA120))	DEVICE='LA120'
	IF(TST.EQ.%LOC(TT$_UNKNOWN))	DEVICE='UNKNOWN'
	IF(TST.EQ.%LOC(TT$_FT3))	DEVICE='FT3'
	IF(TST.EQ.%LOC(TT$_FT4))	DEVICE='FT4'
	IF(TST.EQ.%LOC(TT$_FT5))	DEVICE='FT5'
	IF(TST.EQ.%LOC(TT$_FT6))	DEVICE='FT6'
	IF(TST.EQ.%LOC(TT$_FT7))	DEVICE='FT7'
	RETURN
C
	END
