$!
$!  This is a command file to set up the terminal line to run
$!  the terminal emulation package.
$!
$!    R. E. Burroughs                            11-5-1981
$!
$ Type sys$input
  
         Enter the letter corresponding to the dial-up-line
         that you plan to use.
  
                 A>    _TTB4:
                 B>    _TTB5:

$10:
$ Inquire s1 "                   Terminal >"
$ If s1 .eqs. "a" .or. s1 .eqs. "A" Then Goto start
$ If s1 .eqs. "b" .or. s1 .eqs. "B" Then Goto start
$ Goto 10
$!
$!   Now get the terminal speed
$!
$ start:
$!
$ Inquire terspd "           300 or 1200 baud >"
$ If terspd .eqs. "300" .or. terspd .eqs. "1200" Then Goto start1
$ Goto start
$!
$!   Does he want local or remote echo
$!
$ start1:
$ Inquire loecho " local or remote echo [L,R] >"
$!
$ If loecho .nes. "L" .and. loecho .nes. "R" Then Goto start1
$ If loecho .eqs. "L" Then $Set Term /Echo
$ If loecho .eqs. "R" Then $Set Term /Noecho
$! 
$ If s1 .eqs. "a" .or. s1 .eqs. "A" Then Goto one
$ If s1 .eqs. "b" .or. s1 .eqs. "B" Then Goto two
$!
$!  Now let's allocate the terminal he wants and set the speed
$!
$ one:
$ Allocate _TTB4:
$ If .not. $STATUS Then Goto termerr
$ Assign _TTB4: TT$LUN:
$ Set Term _TTB4:/Noecho/Nointeractive/fulldup/Speed="''terspd'"
$ Goto runterm
$!
$!
$ two:
$ Allocate _TTB5:
$ If .not. $STATUS Then Goto termerr
$ Assign _TTB5: TT$LUN:
$ Set Term _TTB5:/Noecho/Nointeractive/Fulldup/Speed="''terspd'"
$ Goto runterm
$!
$!   Give him a chance to go dial the number he want's
$!
$ runterm:
$ Inquire cr "Press <cr> when you have completed dialing your number"
$!
$ Assign/User_mode tt: sys$output
$ Assign/User_mode tt: sys$input
$ Run DRA0:[Sysexe]Term.exe
$!
$!    Put the terminals back like they were
$!
$ Done:
$ If s1 .eqs. "a" .or. s1 .eqs. "A" Then Deallocate _TTB4:
$ If s1 .eqs. "b" .or. s1 .eqs. "B" Then Deallocate _TTB5:
$ Set Term /Echo
$ Exit
$!
$ termerr:
$ Write sys$output "Can't allocate terminal now"
$ Goto Done
$ Exit
